
/* 
 * Copyright (c) 1993-2005 LAAS/CNRS
 * All rights reserved.
 *
 * Redistribution and use  in source  and binary  forms,  with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *   1. Redistributions of  source  code must retain the  above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice,  this list of  conditions and the following disclaimer in
 *      the  documentation  and/or  other   materials provided  with  the
 *      distribution.
 *
 * THIS  SOFTWARE IS PROVIDED BY  THE  COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND  ANY  EXPRESS OR IMPLIED  WARRANTIES,  INCLUDING,  BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES  OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR  PURPOSE ARE DISCLAIMED. IN  NO EVENT SHALL THE COPYRIGHT
 * HOLDERS OR      CONTRIBUTORS  BE LIABLE FOR   ANY    DIRECT, INDIRECT,
 * INCIDENTAL,  SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF  SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE   OF THIS SOFTWARE, EVEN   IF ADVISED OF   THE POSSIBILITY OF SUCH
 * DAMAGE.
 */

/*------------------  Fichier gnr automatiquement ------------------*/
/*------------------  Ne pas diter manuellement !!! ------------------*/


#ifndef rflex_ERROR_H
#define rflex_ERROR_H

#include "h2errorLib.h"
#include "genom/genomError.h"

#define M_rflex    (6010)

/* -- MODULES ERRORS -------------------------------------------------- */

/* demo errors */
#define S_rflex_BRAKES_ON            H2_ENCODE_ERR(M_rflex     , 1)
#define S_rflex_BAD_REF_DATA         H2_ENCODE_ERR(M_rflex     , 2)
#define S_rflex_BAD_CMD_DATA         H2_ENCODE_ERR(M_rflex     , 3)
#define S_rflex_TRACKING_ON          H2_ENCODE_ERR(M_rflex     , 4)
#define S_rflex_BAD_WDOGREF          H2_ENCODE_ERR(M_rflex     , 5)
#define S_rflex_CANNOT_WRITE_FILE    H2_ENCODE_ERR(M_rflex     , 6)
#define S_rflex_CANNOT_OPEN_FILE     H2_ENCODE_ERR(M_rflex     , 7)
#define S_rflex_GYRO_ERROR           H2_ENCODE_ERR(M_rflex     , 8)
#define S_rflex_SHOCK                H2_ENCODE_ERR(M_rflex     , 9)
#define S_rflex_POSTER_NOT_UPDATED   H2_ENCODE_ERR(M_rflex     , 10)
#define S_rflex_CMD_STOP_TRACK       H2_ENCODE_ERR(M_rflex     , 11)
#define S_rflex_BAD_REF              H2_ENCODE_ERR(M_rflex     , 12)
#define S_rflex_POSTER_NOT_FOUND     H2_ENCODE_ERR(M_rflex     , 13)
#define S_rflex_CANNOT_READ_POSTER   H2_ENCODE_ERR(M_rflex     , 14)
#define S_rflex_NOT_CONNECTED        H2_ENCODE_ERR(M_rflex     , 15)
#define S_rflex_CONNECTION_FAILED    H2_ENCODE_ERR(M_rflex     , 16)
#define S_rflex_REF_NOT_UPDATED      H2_ENCODE_ERR(M_rflex     , 17)
#define S_rflex_LOW_LEVEL_BATTERY    H2_ENCODE_ERR(M_rflex     , 18)
#define S_rflex_MANUAL               H2_ENCODE_ERR(M_rflex     , 19)
#define S_rflex_EMERGENCY_STOP       H2_ENCODE_ERR(M_rflex     , 20)
#define S_rflex_NO_MOTION            H2_ENCODE_ERR(M_rflex     , 21)


/* std errors */
#define S_rflex_stdGenoM_ACTIVITY_INTERRUPTED       393929729   /* 6010<<16 | 0x8000 | 100<<8 | 1 */
#define S_rflex_stdGenoM_TOO_MANY_ACTIVITIES        393929730   /* 6010<<16 | 0x8000 | 100<<8 | 2 */
#define S_rflex_stdGenoM_ACTIVITY_FAILED            393929731   /* 6010<<16 | 0x8000 | 100<<8 | 3 */
#define S_rflex_stdGenoM_WAIT_ABORT_ZOMBIE_ACTIVITY 393929732   /* 6010<<16 | 0x8000 | 100<<8 | 4 */
#define S_rflex_stdGenoM_UNKNOWN_ACTIVITY           393929733   /* 6010<<16 | 0x8000 | 100<<8 | 5 */
#define S_rflex_stdGenoM_FORBIDDEN_ACTIVITY_TRANSITION 393929734   /* 6010<<16 | 0x8000 | 100<<8 | 6 */
#define S_rflex_stdGenoM_SYSTEM_ERROR               393929735   /* 6010<<16 | 0x8000 | 100<<8 | 7 */
#define S_rflex_stdGenoM_ACTIVITY_ALREADY_ENDED     393929736   /* 6010<<16 | 0x8000 | 100<<8 | 8 */
#define S_rflex_stdGenoM_WAIT_INIT_RQST             393929737   /* 6010<<16 | 0x8000 | 100<<8 | 9 */
#define S_rflex_stdGenoM_CONTROL_CODEL_ERROR        393929738   /* 6010<<16 | 0x8000 | 100<<8 | 10 */
#define S_rflex_stdGenoM_EXEC_TASK_SUSPENDED        393929739   /* 6010<<16 | 0x8000 | 100<<8 | 11 */
#define S_rflex_stdGenoM_BAD_BLOCK_TYPE             393929740   /* 6010<<16 | 0x8000 | 100<<8 | 12 */
#define S_rflex_stdGenoM_BAD_POSTER_TYPE            393929741   /* 6010<<16 | 0x8000 | 100<<8 | 13 */



/* static H2_ERROR[] */
#define RFLEX_H2_ERR_MSGS {\
    {"BRAKES_ON", 1}, \
    {"BAD_REF_DATA", 2}, \
    {"BAD_CMD_DATA", 3}, \
    {"TRACKING_ON", 4}, \
    {"BAD_WDOGREF", 5}, \
    {"CANNOT_WRITE_FILE", 6},\
    {"CANNOT_OPEN_FILE", 7},\
    {"GYRO_ERROR", 8},\
    {"SHOCK", 9},\
    {"POSTER_NOT_UPDATED", 10},\
    {"CMD_STOP_TRACK", 11},\
    {"BAD_REF", 12},\
    {"POSTER_NOT_FOUND", 13},\
    {"CANNOT_READ_POSTER", 14},\
    {"NOT_CONNECTED", 15},\
    {"CONNECTION_FAILED", 16},\
    {"REF_NOT_UPDATED", 17},\
    {"LOW_LEVEL_BATTERY", 18},\
    {"MANUAL", 19},\
    {"EMERGENCY_STOP", 20},\
    {"NO_MOTION", 21},\
}

#ifdef __cplusplus
extern "C" {
#endif

extern int rflexRecordH2errMsgs(void);

#ifdef __cplusplus
}
#endif


/*-------------------------- end file loading ---------------------------*/
#endif
