
/* 
 * Copyright (c) 1993-2003,2012 LAAS/CNRS
 * All rights reserved.
 *
 * Redistribution and use  in source  and binary  forms,  with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *   1. Redistributions of  source  code must retain the  above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice,  this list of  conditions and the following disclaimer in
 *      the  documentation  and/or  other   materials provided  with  the
 *      distribution.
 *
 * THIS  SOFTWARE IS PROVIDED BY  THE  COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND  ANY  EXPRESS OR IMPLIED  WARRANTIES,  INCLUDING,  BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES  OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR  PURPOSE ARE DISCLAIMED. IN  NO EVENT SHALL THE COPYRIGHT
 * HOLDERS OR      CONTRIBUTORS  BE LIABLE FOR   ANY    DIRECT, INDIRECT,
 * INCIDENTAL,  SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF  SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE   OF THIS SOFTWARE, EVEN   IF ADVISED OF   THE POSSIBILITY OF SUCH
 * DAMAGE.
 */

/*------------------  Fichier gnr automatiquement ------------------*/
/*------------------  Ne pas diter manuellement !!! ------------------*/

#ifndef rflex_MSG_LIB_H
#define rflex_MSG_LIB_H

#include "portLib.h"
#include "csLib.h"
#include "posterLib.h"
 
#include "rflexType.h"

#define TIME_WAIT_REPLY           /*2000*/ 0
 



/*----------- Tailles des messages et boites aux lettres  ----------*/

/* Taille du buffer utilise dans la bal pour un mesage de taille size
 * (cf servMbox pour UNIX et h2rgnLib pour VXWORKS )
 */


#define BUF_SIZE(size) \
   (size + 4 - (size & 3) + sizeof(LETTER_HDR) + 8)

/**
 ** Boite aux lettres reception requetes 
 **/
#define  RFLEX_MBOX_NAME                  genomInstanceName("rflex")

#define  RFLEX_MAX_RQST_SIZE              128

#define  RFLEX_MBOX_RQST_SIZE       \
 (BUF_SIZE(RFLEX_MAX_RQST_SIZE) * SERV_NMAX_RQST_ID)

/** 
 ** Taille max repliques (serveur)
 **/
#define  RFLEX_MAX_INTERMED_REPLY_SIZE   (sizeof(int))

#define  RFLEX_MAX_REPLY_SIZE             48

/** 
 ** Taille bal clients pour reception repliques 
 **/
#define  RFLEX_CLIENT_MBOX_REPLY_SIZE   \
((BUF_SIZE(RFLEX_MAX_REPLY_SIZE) \
   + BUF_SIZE(RFLEX_MAX_INTERMED_REPLY_SIZE)) \
 * CLIENT_NMAX_RQST_ID)

/*-------------------------- Liste des requetes  -------------------------*/

#define RFLEX_INITCLIENT_RQST 0
#define RFLEX_ENDCLIENT_RQST 1
#define RFLEX_SETWDOGREF_RQST 2
#define RFLEX_GETWDOGREF_RQST 3
#define RFLEX_SETMODE_RQST 4
#define RFLEX_GETMODE_RQST 5
#define RFLEX_POMTAGGING_RQST 6
#define RFLEX_SETPOS_RQST 7
#define RFLEX_SETPOSFROMMEPOSTER_RQST 8
#define RFLEX_SETPOSERR_RQST 9
#define RFLEX_SETVARPARAMS_RQST 10
#define RFLEX_STOP_RQST 11
#define RFLEX_TRACKEND_RQST 12
#define RFLEX_GOTOSPEED_RQST 13
#define RFLEX_TRACKSPEEDSTART_RQST 14
#define RFLEX_TRACKCONFIGSTART_RQST 15
#define RFLEX_GETGEOCONFIG_RQST 16
#define RFLEX_SETGEOCONFIG_RQST 17
#define RFLEX_SONARON_RQST 18
#define RFLEX_SONAROFF_RQST 19
#define RFLEX_BRAKEON_RQST 20
#define RFLEX_BRAKEOFF_RQST 21
#define RFLEX_GETJOYSTICK_RQST 22
#define RFLEX_MONITORBATTERY_RQST 23
#define RFLEX_GYRO_RQST 24
#define RFLEX_GETGYRO_RQST 25
#define RFLEX_SETODOMETRYMETHOD_RQST 26
#define RFLEX_LOG_RQST 27
#define RFLEX_STOPLOG_RQST 28
#define RFLEX_ABORT_RQST 29


/*---------------- PROTOTYPES DES FONCTIONS EXTERNES ------------------*/

#ifdef __cplusplus
extern "C" {
#endif

STATUS rflexClientInit (CLIENT_ID *pClientId);

STATUS rflexClientEnd (CLIENT_ID clientId);

int rflexAbortRqstSend (CLIENT_ID clientId, 
			   int *pRqstId,
			   int *activity,
			   int replyTimeOut);

int rflexAbortReplyRcv (CLIENT_ID clientId, 
			   int rqstId, 
			   int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY */
			   int *bilan);

int rflexAbortRqstAndRcv (CLIENT_ID clientId, 
			     int *activity,
			     int *bilan);




extern STATUS rflexInitClientRqstSend (CLIENT_ID clientId, int *pRqstId,
					 RFLEX_CLIENT_STR *(in_client),
					 int replyTimeOut);

extern int rflexInitClientReplyRcv (CLIENT_ID clientId, int rqstId, 
				      int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY 
						     BLOCK_ON_INTERMED_REPLY */
				      
				      int *activity, int *bilan);


extern int rflexInitClientRqstAndAck (CLIENT_ID clientId, int *pRqstId,
					int replyTimeOut,
					RFLEX_CLIENT_STR *(in_client), 
					
					int *activity, int *bilan);

extern int rflexInitClientRqstAndRcv (CLIENT_ID clientId, 
					int replyTimeOut,
					RFLEX_CLIENT_STR *(in_client), 
					
					int *activity,
					int *bilan);




extern STATUS rflexEndClientRqstSend (CLIENT_ID clientId, int *pRqstId,
					 
					 int replyTimeOut);

extern int rflexEndClientReplyRcv (CLIENT_ID clientId, int rqstId, 
				      int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY 
						     BLOCK_ON_INTERMED_REPLY */
				      
				      int *activity, int *bilan);


extern int rflexEndClientRqstAndAck (CLIENT_ID clientId, int *pRqstId,
					int replyTimeOut,
					 
					
					int *activity, int *bilan);

extern int rflexEndClientRqstAndRcv (CLIENT_ID clientId, 
					int replyTimeOut,
					 
					
					int *activity,
					int *bilan);




extern STATUS rflexSetWdogRefRqstSend (CLIENT_ID clientId, 
					 int *pRqstId,
					 unsigned int *(in_WatchDogRef),
					 int replyTimeOut);

int rflexSetWdogRefReplyRcv (CLIENT_ID clientId, 
			       int rqstId, 
			       int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY */
			       
			       int *bilan);

int rflexSetWdogRefRqstAndRcv (CLIENT_ID clientId, 
				 unsigned int *(in_WatchDogRef), 
				 
				 int *bilan);




extern STATUS rflexGetWdogRefRqstSend (CLIENT_ID clientId, 
					 int *pRqstId,
					 
					 int replyTimeOut);

int rflexGetWdogRefReplyRcv (CLIENT_ID clientId, 
			       int rqstId, 
			       int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY */
			       unsigned int *(out_WatchDogRef),
			       int *bilan);

int rflexGetWdogRefRqstAndRcv (CLIENT_ID clientId, 
				  
				 unsigned int *(out_WatchDogRef),
				 int *bilan);




extern STATUS rflexSetModeRqstSend (CLIENT_ID clientId, 
					 int *pRqstId,
					 RFLEX_MODE *(in_mode),
					 int replyTimeOut);

int rflexSetModeReplyRcv (CLIENT_ID clientId, 
			       int rqstId, 
			       int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY */
			       
			       int *bilan);

int rflexSetModeRqstAndRcv (CLIENT_ID clientId, 
				 RFLEX_MODE *(in_mode), 
				 
				 int *bilan);




extern STATUS rflexGetModeRqstSend (CLIENT_ID clientId, 
					 int *pRqstId,
					 
					 int replyTimeOut);

int rflexGetModeReplyRcv (CLIENT_ID clientId, 
			       int rqstId, 
			       int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY */
			       RFLEX_MODE *(out_mode),
			       int *bilan);

int rflexGetModeRqstAndRcv (CLIENT_ID clientId, 
				  
				 RFLEX_MODE *(out_mode),
				 int *bilan);




extern STATUS rflexPomTaggingRqstSend (CLIENT_ID clientId, 
					 int *pRqstId,
					 RFLEX_POM_TAGGING *(in_pomTagging),
					 int replyTimeOut);

int rflexPomTaggingReplyRcv (CLIENT_ID clientId, 
			       int rqstId, 
			       int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY */
			       
			       int *bilan);

int rflexPomTaggingRqstAndRcv (CLIENT_ID clientId, 
				 RFLEX_POM_TAGGING *(in_pomTagging), 
				 
				 int *bilan);




extern STATUS rflexSetPosRqstSend (CLIENT_ID clientId, 
					 int *pRqstId,
					 RFLEX_CART_3DCONFIG *(in_setPosStr),
					 int replyTimeOut);

int rflexSetPosReplyRcv (CLIENT_ID clientId, 
			       int rqstId, 
			       int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY */
			       
			       int *bilan);

int rflexSetPosRqstAndRcv (CLIENT_ID clientId, 
				 RFLEX_CART_3DCONFIG *(in_setPosStr), 
				 
				 int *bilan);




extern STATUS rflexSetPosFromMEPosterRqstSend (CLIENT_ID clientId, int *pRqstId,
					 RFLEX_STRING *(in_posMEPosterName),
					 int replyTimeOut);

extern int rflexSetPosFromMEPosterReplyRcv (CLIENT_ID clientId, int rqstId, 
				      int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY 
						     BLOCK_ON_INTERMED_REPLY */
				      
				      int *activity, int *bilan);


extern int rflexSetPosFromMEPosterRqstAndAck (CLIENT_ID clientId, int *pRqstId,
					int replyTimeOut,
					RFLEX_STRING *(in_posMEPosterName), 
					
					int *activity, int *bilan);

extern int rflexSetPosFromMEPosterRqstAndRcv (CLIENT_ID clientId, 
					int replyTimeOut,
					RFLEX_STRING *(in_posMEPosterName), 
					
					int *activity,
					int *bilan);




extern STATUS rflexSetPosErrRqstSend (CLIENT_ID clientId, 
					 int *pRqstId,
					 GENPOS_CART_CONFIG_VAR *(in_setVarTab),
					 int replyTimeOut);

int rflexSetPosErrReplyRcv (CLIENT_ID clientId, 
			       int rqstId, 
			       int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY */
			       
			       int *bilan);

int rflexSetPosErrRqstAndRcv (CLIENT_ID clientId, 
				 GENPOS_CART_CONFIG_VAR *(in_setVarTab), 
				 
				 int *bilan);




extern STATUS rflexSetVarParamsRqstSend (CLIENT_ID clientId, 
					 int *pRqstId,
					 RFLEX_VAR_PARAMS *(in_varParams),
					 int replyTimeOut);

int rflexSetVarParamsReplyRcv (CLIENT_ID clientId, 
			       int rqstId, 
			       int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY */
			       
			       int *bilan);

int rflexSetVarParamsRqstAndRcv (CLIENT_ID clientId, 
				 RFLEX_VAR_PARAMS *(in_varParams), 
				 
				 int *bilan);




extern STATUS rflexStopRqstSend (CLIENT_ID clientId, int *pRqstId,
					 
					 int replyTimeOut);

extern int rflexStopReplyRcv (CLIENT_ID clientId, int rqstId, 
				      int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY 
						     BLOCK_ON_INTERMED_REPLY */
				      
				      int *activity, int *bilan);


extern int rflexStopRqstAndAck (CLIENT_ID clientId, int *pRqstId,
					int replyTimeOut,
					 
					
					int *activity, int *bilan);

extern int rflexStopRqstAndRcv (CLIENT_ID clientId, 
					int replyTimeOut,
					 
					
					int *activity,
					int *bilan);




extern STATUS rflexTrackEndRqstSend (CLIENT_ID clientId, 
					 int *pRqstId,
					 
					 int replyTimeOut);

int rflexTrackEndReplyRcv (CLIENT_ID clientId, 
			       int rqstId, 
			       int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY */
			       
			       int *bilan);

int rflexTrackEndRqstAndRcv (CLIENT_ID clientId, 
				  
				 
				 int *bilan);




extern STATUS rflexGotoSpeedRqstSend (CLIENT_ID clientId, 
					 int *pRqstId,
					 GENPOS_CART_SPEED *(in_speedRef),
					 int replyTimeOut);

int rflexGotoSpeedReplyRcv (CLIENT_ID clientId, 
			       int rqstId, 
			       int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY */
			       
			       int *bilan);

int rflexGotoSpeedRqstAndRcv (CLIENT_ID clientId, 
				 GENPOS_CART_SPEED *(in_speedRef), 
				 
				 int *bilan);




extern STATUS rflexTrackSpeedStartRqstSend (CLIENT_ID clientId, int *pRqstId,
					 GENPOS_POSTER_NAME *(in_posterName),
					 int replyTimeOut);

extern int rflexTrackSpeedStartReplyRcv (CLIENT_ID clientId, int rqstId, 
				      int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY 
						     BLOCK_ON_INTERMED_REPLY */
				      
				      int *activity, int *bilan);


extern int rflexTrackSpeedStartRqstAndAck (CLIENT_ID clientId, int *pRqstId,
					int replyTimeOut,
					GENPOS_POSTER_NAME *(in_posterName), 
					
					int *activity, int *bilan);

extern int rflexTrackSpeedStartRqstAndRcv (CLIENT_ID clientId, 
					int replyTimeOut,
					GENPOS_POSTER_NAME *(in_posterName), 
					
					int *activity,
					int *bilan);




extern STATUS rflexTrackConfigStartRqstSend (CLIENT_ID clientId, int *pRqstId,
					 GENPOS_POSTER_NAME *(in_posterName),
					 int replyTimeOut);

extern int rflexTrackConfigStartReplyRcv (CLIENT_ID clientId, int rqstId, 
				      int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY 
						     BLOCK_ON_INTERMED_REPLY */
				      
				      int *activity, int *bilan);


extern int rflexTrackConfigStartRqstAndAck (CLIENT_ID clientId, int *pRqstId,
					int replyTimeOut,
					GENPOS_POSTER_NAME *(in_posterName), 
					
					int *activity, int *bilan);

extern int rflexTrackConfigStartRqstAndRcv (CLIENT_ID clientId, 
					int replyTimeOut,
					GENPOS_POSTER_NAME *(in_posterName), 
					
					int *activity,
					int *bilan);




extern STATUS rflexGetGeoConfigRqstSend (CLIENT_ID clientId, 
					 int *pRqstId,
					 
					 int replyTimeOut);

int rflexGetGeoConfigReplyRcv (CLIENT_ID clientId, 
			       int rqstId, 
			       int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY */
			       RFLEX_GEOM_PARAM_STR *(out_geomParams),
			       int *bilan);

int rflexGetGeoConfigRqstAndRcv (CLIENT_ID clientId, 
				  
				 RFLEX_GEOM_PARAM_STR *(out_geomParams),
				 int *bilan);




extern STATUS rflexSetGeoConfigRqstSend (CLIENT_ID clientId, 
					 int *pRqstId,
					 RFLEX_GEOM_PARAM_STR *(in_geomParams),
					 int replyTimeOut);

int rflexSetGeoConfigReplyRcv (CLIENT_ID clientId, 
			       int rqstId, 
			       int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY */
			       
			       int *bilan);

int rflexSetGeoConfigRqstAndRcv (CLIENT_ID clientId, 
				 RFLEX_GEOM_PARAM_STR *(in_geomParams), 
				 
				 int *bilan);




extern STATUS rflexSonarOnRqstSend (CLIENT_ID clientId, int *pRqstId,
					 
					 int replyTimeOut);

extern int rflexSonarOnReplyRcv (CLIENT_ID clientId, int rqstId, 
				      int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY 
						     BLOCK_ON_INTERMED_REPLY */
				      
				      int *activity, int *bilan);


extern int rflexSonarOnRqstAndAck (CLIENT_ID clientId, int *pRqstId,
					int replyTimeOut,
					 
					
					int *activity, int *bilan);

extern int rflexSonarOnRqstAndRcv (CLIENT_ID clientId, 
					int replyTimeOut,
					 
					
					int *activity,
					int *bilan);




extern STATUS rflexSonarOffRqstSend (CLIENT_ID clientId, int *pRqstId,
					 
					 int replyTimeOut);

extern int rflexSonarOffReplyRcv (CLIENT_ID clientId, int rqstId, 
				      int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY 
						     BLOCK_ON_INTERMED_REPLY */
				      
				      int *activity, int *bilan);


extern int rflexSonarOffRqstAndAck (CLIENT_ID clientId, int *pRqstId,
					int replyTimeOut,
					 
					
					int *activity, int *bilan);

extern int rflexSonarOffRqstAndRcv (CLIENT_ID clientId, 
					int replyTimeOut,
					 
					
					int *activity,
					int *bilan);




extern STATUS rflexBrakeOnRqstSend (CLIENT_ID clientId, int *pRqstId,
					 
					 int replyTimeOut);

extern int rflexBrakeOnReplyRcv (CLIENT_ID clientId, int rqstId, 
				      int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY 
						     BLOCK_ON_INTERMED_REPLY */
				      
				      int *activity, int *bilan);


extern int rflexBrakeOnRqstAndAck (CLIENT_ID clientId, int *pRqstId,
					int replyTimeOut,
					 
					
					int *activity, int *bilan);

extern int rflexBrakeOnRqstAndRcv (CLIENT_ID clientId, 
					int replyTimeOut,
					 
					
					int *activity,
					int *bilan);




extern STATUS rflexBrakeOffRqstSend (CLIENT_ID clientId, int *pRqstId,
					 
					 int replyTimeOut);

extern int rflexBrakeOffReplyRcv (CLIENT_ID clientId, int rqstId, 
				      int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY 
						     BLOCK_ON_INTERMED_REPLY */
				      
				      int *activity, int *bilan);


extern int rflexBrakeOffRqstAndAck (CLIENT_ID clientId, int *pRqstId,
					int replyTimeOut,
					 
					
					int *activity, int *bilan);

extern int rflexBrakeOffRqstAndRcv (CLIENT_ID clientId, 
					int replyTimeOut,
					 
					
					int *activity,
					int *bilan);




extern STATUS rflexGetJoystickRqstSend (CLIENT_ID clientId, int *pRqstId,
					 
					 int replyTimeOut);

extern int rflexGetJoystickReplyRcv (CLIENT_ID clientId, int rqstId, 
				      int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY 
						     BLOCK_ON_INTERMED_REPLY */
				      RFLEX_JOYSTICK_STR *(out_joystickState),
				      int *activity, int *bilan);


extern int rflexGetJoystickRqstAndAck (CLIENT_ID clientId, int *pRqstId,
					int replyTimeOut,
					 
					RFLEX_JOYSTICK_STR *(out_joystickState),
					int *activity, int *bilan);

extern int rflexGetJoystickRqstAndRcv (CLIENT_ID clientId, 
					int replyTimeOut,
					 
					RFLEX_JOYSTICK_STR *(out_joystickState),
					int *activity,
					int *bilan);




extern STATUS rflexMonitorBatteryRqstSend (CLIENT_ID clientId, int *pRqstId,
					 RFLEX_BATTERY_STATUS *(in_statusToMonitor),
					 int replyTimeOut);

extern int rflexMonitorBatteryReplyRcv (CLIENT_ID clientId, int rqstId, 
				      int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY 
						     BLOCK_ON_INTERMED_REPLY */
				      
				      int *activity, int *bilan);


extern int rflexMonitorBatteryRqstAndAck (CLIENT_ID clientId, int *pRqstId,
					int replyTimeOut,
					RFLEX_BATTERY_STATUS *(in_statusToMonitor), 
					
					int *activity, int *bilan);

extern int rflexMonitorBatteryRqstAndRcv (CLIENT_ID clientId, 
					int replyTimeOut,
					RFLEX_BATTERY_STATUS *(in_statusToMonitor), 
					
					int *activity,
					int *bilan);




extern STATUS rflexGyroRqstSend (CLIENT_ID clientId, int *pRqstId,
					 RFLEX_GYRO_PARAMS *(in_params),
					 int replyTimeOut);

extern int rflexGyroReplyRcv (CLIENT_ID clientId, int rqstId, 
				      int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY 
						     BLOCK_ON_INTERMED_REPLY */
				      
				      int *activity, int *bilan);


extern int rflexGyroRqstAndAck (CLIENT_ID clientId, int *pRqstId,
					int replyTimeOut,
					RFLEX_GYRO_PARAMS *(in_params), 
					
					int *activity, int *bilan);

extern int rflexGyroRqstAndRcv (CLIENT_ID clientId, 
					int replyTimeOut,
					RFLEX_GYRO_PARAMS *(in_params), 
					
					int *activity,
					int *bilan);




extern STATUS rflexGetGyroRqstSend (CLIENT_ID clientId, 
					 int *pRqstId,
					 
					 int replyTimeOut);

int rflexGetGyroReplyRcv (CLIENT_ID clientId, 
			       int rqstId, 
			       int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY */
			       RFLEX_GYRO_PARAMS *(out_params),
			       int *bilan);

int rflexGetGyroRqstAndRcv (CLIENT_ID clientId, 
				  
				 RFLEX_GYRO_PARAMS *(out_params),
				 int *bilan);




extern STATUS rflexSetOdometryMethodRqstSend (CLIENT_ID clientId, int *pRqstId,
					 RFLEX_ODOMETRY_METHOD *(in_odometryCommand),
					 int replyTimeOut);

extern int rflexSetOdometryMethodReplyRcv (CLIENT_ID clientId, int rqstId, 
				      int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY 
						     BLOCK_ON_INTERMED_REPLY */
				      
				      int *activity, int *bilan);


extern int rflexSetOdometryMethodRqstAndAck (CLIENT_ID clientId, int *pRqstId,
					int replyTimeOut,
					RFLEX_ODOMETRY_METHOD *(in_odometryCommand), 
					
					int *activity, int *bilan);

extern int rflexSetOdometryMethodRqstAndRcv (CLIENT_ID clientId, 
					int replyTimeOut,
					RFLEX_ODOMETRY_METHOD *(in_odometryCommand), 
					
					int *activity,
					int *bilan);




extern STATUS rflexLogRqstSend (CLIENT_ID clientId, int *pRqstId,
					 GEN_STRING128 *(in_fileName),
					 int replyTimeOut);

extern int rflexLogReplyRcv (CLIENT_ID clientId, int rqstId, 
				      int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY 
						     BLOCK_ON_INTERMED_REPLY */
				      
				      int *activity, int *bilan);


extern int rflexLogRqstAndAck (CLIENT_ID clientId, int *pRqstId,
					int replyTimeOut,
					GEN_STRING128 *(in_fileName), 
					
					int *activity, int *bilan);

extern int rflexLogRqstAndRcv (CLIENT_ID clientId, 
					int replyTimeOut,
					GEN_STRING128 *(in_fileName), 
					
					int *activity,
					int *bilan);




extern STATUS rflexStopLogRqstSend (CLIENT_ID clientId, 
					 int *pRqstId,
					 
					 int replyTimeOut);

int rflexStopLogReplyRcv (CLIENT_ID clientId, 
			       int rqstId, 
			       int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY */
			       
			       int *bilan);

int rflexStopLogRqstAndRcv (CLIENT_ID clientId, 
				  
				 
				 int *bilan);


#ifdef __cplusplus
}
#endif
#endif /* rflex_MSG_LIB_H */

