
/* 
 * Copyright (c) 1993-2003 LAAS/CNRS
 * All rights reserved.
 *
 * Redistribution and use  in source  and binary  forms,  with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *   1. Redistributions of  source  code must retain the  above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice,  this list of  conditions and the following disclaimer in
 *      the  documentation  and/or  other   materials provided  with  the
 *      distribution.
 *
 * THIS  SOFTWARE IS PROVIDED BY  THE  COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND  ANY  EXPRESS OR IMPLIED  WARRANTIES,  INCLUDING,  BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES  OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR  PURPOSE ARE DISCLAIMED. IN  NO EVENT SHALL THE COPYRIGHT
 * HOLDERS OR      CONTRIBUTORS  BE LIABLE FOR   ANY    DIRECT, INDIRECT,
 * INCIDENTAL,  SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF  SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE   OF THIS SOFTWARE, EVEN   IF ADVISED OF   THE POSSIBILITY OF SUCH
 * DAMAGE.
 */

/*------------------  Fichier gnr automatiquement ------------------*/
/*------------------  Ne pas diter manuellement !!! ------------------*/

#ifndef rflex_TCLSERV_CLIENT_MSG_LIB_H
#define rflex_TCLSERV_CLIENT_MSG_LIB_H

#include <server/rflexType.h>

/*---------------- PROTOTYPES DES FONCTIONS EXTERNES ------------------*/

#ifdef __cplusplus
extern "C" {
#endif

int rflexTclservClientInit (TCLSERV_CLIENT_ID pClientId);

int rflexTclservClientEnd (TCLSERV_CLIENT_ID clientId);



int rflexTclservClientInitClientRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId ,
				 RFLEX_CLIENT_STR *(in_client) 
		);

int rflexTclservClientInitClientReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int rflexTclservClientInitClientRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				RFLEX_CLIENT_STR *(in_client) ,
				
				int *bilan);

int rflexTclservClientInitClientRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					RFLEX_CLIENT_STR *(in_client) ,
					
					int *bilan);




int rflexTclservClientEndClientRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId //,
				  
		);

int rflexTclservClientEndClientReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int rflexTclservClientEndClientRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				 //,
				
				int *bilan);

int rflexTclservClientEndClientRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					 //,
					
					int *bilan);




int rflexTclservClientSetWdogRefRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId ,
					 unsigned int *(in_WatchDogRef)
		);

int rflexTclservClientSetWdogRefReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       
			       int *bilan);

int rflexTclservClientSetWdogRefRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				 unsigned int *(in_WatchDogRef) ,
				 
				 int *bilan);




int rflexTclservClientGetWdogRefRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId //,
					 
		);

int rflexTclservClientGetWdogRefReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       unsigned int *(out_WatchDogRef),
			       int *bilan);

int rflexTclservClientGetWdogRefRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				  //,
				 unsigned int *(out_WatchDogRef),
				 int *bilan);




int rflexTclservClientSetModeRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId ,
					 RFLEX_MODE *(in_mode)
		);

int rflexTclservClientSetModeReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       
			       int *bilan);

int rflexTclservClientSetModeRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				 RFLEX_MODE *(in_mode) ,
				 
				 int *bilan);




int rflexTclservClientGetModeRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId //,
					 
		);

int rflexTclservClientGetModeReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       RFLEX_MODE *(out_mode),
			       int *bilan);

int rflexTclservClientGetModeRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				  //,
				 RFLEX_MODE *(out_mode),
				 int *bilan);




int rflexTclservClientPomTaggingRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId ,
					 RFLEX_POM_TAGGING *(in_pomTagging)
		);

int rflexTclservClientPomTaggingReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       
			       int *bilan);

int rflexTclservClientPomTaggingRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				 RFLEX_POM_TAGGING *(in_pomTagging) ,
				 
				 int *bilan);




int rflexTclservClientSetPosRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId ,
					 RFLEX_CART_3DCONFIG *(in_setPosStr)
		);

int rflexTclservClientSetPosReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       
			       int *bilan);

int rflexTclservClientSetPosRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				 RFLEX_CART_3DCONFIG *(in_setPosStr) ,
				 
				 int *bilan);




int rflexTclservClientSetPosFromMEPosterRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId ,
				 RFLEX_STRING *(in_posMEPosterName) 
		);

int rflexTclservClientSetPosFromMEPosterReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int rflexTclservClientSetPosFromMEPosterRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				RFLEX_STRING *(in_posMEPosterName) ,
				
				int *bilan);

int rflexTclservClientSetPosFromMEPosterRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					RFLEX_STRING *(in_posMEPosterName) ,
					
					int *bilan);




int rflexTclservClientSetPosErrRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId ,
					 GENPOS_CART_CONFIG_VAR *(in_setVarTab)
		);

int rflexTclservClientSetPosErrReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       
			       int *bilan);

int rflexTclservClientSetPosErrRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				 GENPOS_CART_CONFIG_VAR *(in_setVarTab) ,
				 
				 int *bilan);




int rflexTclservClientSetVarParamsRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId ,
					 RFLEX_VAR_PARAMS *(in_varParams)
		);

int rflexTclservClientSetVarParamsReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       
			       int *bilan);

int rflexTclservClientSetVarParamsRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				 RFLEX_VAR_PARAMS *(in_varParams) ,
				 
				 int *bilan);




int rflexTclservClientStopRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId //,
				  
		);

int rflexTclservClientStopReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int rflexTclservClientStopRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				 //,
				
				int *bilan);

int rflexTclservClientStopRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					 //,
					
					int *bilan);




int rflexTclservClientTrackEndRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId //,
					 
		);

int rflexTclservClientTrackEndReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       
			       int *bilan);

int rflexTclservClientTrackEndRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				  //,
				 
				 int *bilan);




int rflexTclservClientGotoSpeedRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId ,
					 GENPOS_CART_SPEED *(in_speedRef)
		);

int rflexTclservClientGotoSpeedReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       
			       int *bilan);

int rflexTclservClientGotoSpeedRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				 GENPOS_CART_SPEED *(in_speedRef) ,
				 
				 int *bilan);




int rflexTclservClientTrackSpeedStartRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId ,
				 GENPOS_POSTER_NAME *(in_posterName) 
		);

int rflexTclservClientTrackSpeedStartReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int rflexTclservClientTrackSpeedStartRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				GENPOS_POSTER_NAME *(in_posterName) ,
				
				int *bilan);

int rflexTclservClientTrackSpeedStartRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					GENPOS_POSTER_NAME *(in_posterName) ,
					
					int *bilan);




int rflexTclservClientTrackConfigStartRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId ,
				 GENPOS_POSTER_NAME *(in_posterName) 
		);

int rflexTclservClientTrackConfigStartReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int rflexTclservClientTrackConfigStartRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				GENPOS_POSTER_NAME *(in_posterName) ,
				
				int *bilan);

int rflexTclservClientTrackConfigStartRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					GENPOS_POSTER_NAME *(in_posterName) ,
					
					int *bilan);




int rflexTclservClientGetGeoConfigRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId //,
					 
		);

int rflexTclservClientGetGeoConfigReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       RFLEX_GEOM_PARAM_STR *(out_geomParams),
			       int *bilan);

int rflexTclservClientGetGeoConfigRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				  //,
				 RFLEX_GEOM_PARAM_STR *(out_geomParams),
				 int *bilan);




int rflexTclservClientSetGeoConfigRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId ,
					 RFLEX_GEOM_PARAM_STR *(in_geomParams)
		);

int rflexTclservClientSetGeoConfigReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       
			       int *bilan);

int rflexTclservClientSetGeoConfigRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				 RFLEX_GEOM_PARAM_STR *(in_geomParams) ,
				 
				 int *bilan);




int rflexTclservClientSonarOnRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId //,
				  
		);

int rflexTclservClientSonarOnReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int rflexTclservClientSonarOnRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				 //,
				
				int *bilan);

int rflexTclservClientSonarOnRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					 //,
					
					int *bilan);




int rflexTclservClientSonarOffRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId //,
				  
		);

int rflexTclservClientSonarOffReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int rflexTclservClientSonarOffRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				 //,
				
				int *bilan);

int rflexTclservClientSonarOffRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					 //,
					
					int *bilan);




int rflexTclservClientBrakeOnRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId //,
				  
		);

int rflexTclservClientBrakeOnReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int rflexTclservClientBrakeOnRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				 //,
				
				int *bilan);

int rflexTclservClientBrakeOnRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					 //,
					
					int *bilan);




int rflexTclservClientBrakeOffRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId //,
				  
		);

int rflexTclservClientBrakeOffReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int rflexTclservClientBrakeOffRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				 //,
				
				int *bilan);

int rflexTclservClientBrakeOffRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					 //,
					
					int *bilan);




int rflexTclservClientGetJoystickRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId //,
				  
		);

int rflexTclservClientGetJoystickReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      RFLEX_JOYSTICK_STR *(out_joystickState),
			      int *bilan);


int rflexTclservClientGetJoystickRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				 //,
				RFLEX_JOYSTICK_STR *(out_joystickState),
				int *bilan);

int rflexTclservClientGetJoystickRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					 //,
					RFLEX_JOYSTICK_STR *(out_joystickState),
					int *bilan);




int rflexTclservClientMonitorBatteryRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId ,
				 RFLEX_BATTERY_STATUS *(in_statusToMonitor) 
		);

int rflexTclservClientMonitorBatteryReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int rflexTclservClientMonitorBatteryRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				RFLEX_BATTERY_STATUS *(in_statusToMonitor) ,
				
				int *bilan);

int rflexTclservClientMonitorBatteryRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					RFLEX_BATTERY_STATUS *(in_statusToMonitor) ,
					
					int *bilan);




int rflexTclservClientGyroRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId ,
				 RFLEX_GYRO_PARAMS *(in_params) 
		);

int rflexTclservClientGyroReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int rflexTclservClientGyroRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				RFLEX_GYRO_PARAMS *(in_params) ,
				
				int *bilan);

int rflexTclservClientGyroRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					RFLEX_GYRO_PARAMS *(in_params) ,
					
					int *bilan);




int rflexTclservClientGetGyroRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId //,
					 
		);

int rflexTclservClientGetGyroReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       RFLEX_GYRO_PARAMS *(out_params),
			       int *bilan);

int rflexTclservClientGetGyroRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				  //,
				 RFLEX_GYRO_PARAMS *(out_params),
				 int *bilan);




int rflexTclservClientSetOdometryMethodRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId ,
				 RFLEX_ODOMETRY_METHOD *(in_odometryCommand) 
		);

int rflexTclservClientSetOdometryMethodReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int rflexTclservClientSetOdometryMethodRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				RFLEX_ODOMETRY_METHOD *(in_odometryCommand) ,
				
				int *bilan);

int rflexTclservClientSetOdometryMethodRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					RFLEX_ODOMETRY_METHOD *(in_odometryCommand) ,
					
					int *bilan);




int rflexTclservClientLogRqstSend (
				 TCLSERV_CLIENT_ID clientId, 
				 ssize_t *pRqstId ,
				 GEN_STRING128 *(in_fileName) 
		);

int rflexTclservClientLogReplyRcv (
			      TCLSERV_CLIENT_ID clientId, 
				  ssize_t  rqstId, 
			      
			      int *bilan);


int rflexTclservClientLogRqstAndAck (
			    TCLSERV_CLIENT_ID clientId, 
				ssize_t *pRqstId,
				GEN_STRING128 *(in_fileName) ,
				
				int *bilan);

int rflexTclservClientLogRqstAndRcv (
				    TCLSERV_CLIENT_ID clientId, 
					GEN_STRING128 *(in_fileName) ,
					
					int *bilan);




int rflexTclservClientStopLogRqstSend (
					 TCLSERV_CLIENT_ID clientId, 
					 ssize_t *pRqstId //,
					 
		);

int rflexTclservClientStopLogReplyRcv (
				   TCLSERV_CLIENT_ID clientId, 
			       ssize_t rqstId, 
			       
			       int *bilan);

int rflexTclservClientStopLogRqstAndRcv (
				 TCLSERV_CLIENT_ID clientId, 
				  //,
				 
				 int *bilan);


#ifdef __cplusplus
}
#endif
#endif /* rflexTCLSERV_CLIENT_MSG_LIB_H */

