
#
# Copyright (c) 1999-2003 LAAS/CNRS
# All rights reserved.
#
# Redistribution  and  use in source   and binary forms,  with or without
# modification, are permitted provided that  the following conditions are
# met:
#
#   1. Redistributions  of  source code must  retain  the above copyright
#      notice, this list of conditions and the following disclaimer.
#   2. Redistributions in binary form must  reproduce the above copyright
#      notice,  this list of  conditions and  the following disclaimer in
#      the  documentation   and/or  other  materials   provided with  the
#      distribution.
#
# THIS SOFTWARE IS PROVIDED BY THE  AUTHOR AND CONTRIBUTORS ``AS IS'' AND
# ANY  EXPRESS OR IMPLIED WARRANTIES, INCLUDING,  BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES   OF MERCHANTABILITY AND  FITNESS  FOR  A PARTICULAR
# PURPOSE ARE DISCLAIMED.  IN NO  EVENT SHALL THE AUTHOR OR  CONTRIBUTORS
# BE LIABLE FOR ANY DIRECT, INDIRECT,  INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING,  BUT  NOT LIMITED TO, PROCUREMENT  OF
# SUBSTITUTE  GOODS OR SERVICES;  LOSS   OF  USE,  DATA, OR PROFITS;   OR
# BUSINESS  INTERRUPTION) HOWEVER CAUSED AND  ON ANY THEORY OF LIABILITY,
# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
# OTHERWISE) ARISING IN ANY WAY OUT OF THE  USE OF THIS SOFTWARE, EVEN IF
# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
#

#
# This file was automagically generated.
# Manual editing not recommended. Changes will be overridden.
#

if { [lsearch [interp hidden] rflexInstall] >= 0 } {
    interp expose {} rflexInstall
}

proc ::rflexInstall { name } {
    foreach rqst { "InitClient" "EndClient" "SetWdogRef" "GetWdogRef" "SetMode" "GetMode" "PomTagging" "SetPos" "SetPosFromMEPoster" "SetPosErr" "SetVarParams" "Stop" "TrackEnd" "GotoSpeed" "TrackSpeedStart" "TrackConfigStart" "GetGeoConfig" "SetGeoConfig" "SonarOn" "SonarOff" "BrakeOn" "BrakeOff" "GetJoystick" "MonitorBattery" "Gyro" "GetGyro" "SetOdometryMethod" "Log" "StopLog" "RobotPositionPosterRead" "RobotrawAxisPosterRead" "RobotPosErrorPosterRead" "RobotconfigRefPosterRead" "RobotspeedRefPosterRead" "RobotsystemStatePosterRead" "RobotmiscOdoPosterRead" "MEPosPosPosterRead" "SonarsConfigConfigPosterRead" "SonarsRhoRangePosterRead" "SonarsCartMeasureInRobotCartPosterRead"  } {
	interp alias {} ${name}::$rqst {} interp invoke {} rflex$rqst $name
    }
}

interp hide {} rflexInstall




# InitClient ----------------------------------------------------------

if { [lsearch [interp hidden] rflexInitClient] >= 0 } {
    interp expose {} rflexInitClient
}
if { [lsearch [interp hidden] rflexInitClientFormatOutput] >= 0 } {
    interp expose {} rflexInitClientFormatOutput
}

proc ::rflexInitClient { name args } {
    set format {}
    lappend format [list string "client.deviceName" "" ]
    lappend format [list int "client.baudRate" 0 ]

    return [ ::cs::rqstSend "${name}" "InitClient" \
	"** undocumented **" \
	"RFLEX_CLIENT_STR\n| char deviceName\[16\]\n| int baudRate\n" \
	2 \
	$format \
	$args ]
}


proc ::rflexInitClientFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} rflexInitClient
interp hide {} rflexInitClientFormatOutput





# EndClient ----------------------------------------------------------

if { [lsearch [interp hidden] rflexEndClient] >= 0 } {
    interp expose {} rflexEndClient
}
if { [lsearch [interp hidden] rflexEndClientFormatOutput] >= 0 } {
    interp expose {} rflexEndClientFormatOutput
}

proc ::rflexEndClient { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "EndClient" \
	"** undocumented **" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::rflexEndClientFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} rflexEndClient
interp hide {} rflexEndClientFormatOutput





# SetWdogRef ----------------------------------------------------------

if { [lsearch [interp hidden] rflexSetWdogRef] >= 0 } {
    interp expose {} rflexSetWdogRef
}
if { [lsearch [interp hidden] rflexSetWdogRefFormatOutput] >= 0 } {
    interp expose {} rflexSetWdogRefFormatOutput
}

proc ::rflexSetWdogRef { name args } {
    set format {}
    lappend format [list int "WatchDogRef" 0 ]

    return [ ::cs::rqstSend "${name}" "SetWdogRef" \
	"** undocumented **" \
	"unsigned int WatchDogRef\n" \
	1 \
	$format \
	$args ]
}


proc ::rflexSetWdogRefFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} rflexSetWdogRef
interp hide {} rflexSetWdogRefFormatOutput





# GetWdogRef ----------------------------------------------------------

if { [lsearch [interp hidden] rflexGetWdogRef] >= 0 } {
    interp expose {} rflexGetWdogRef
}
if { [lsearch [interp hidden] rflexGetWdogRefFormatOutput] >= 0 } {
    interp expose {} rflexGetWdogRefFormatOutput
}

proc ::rflexGetWdogRef { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "GetWdogRef" \
	"** undocumented **" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::rflexGetWdogRefFormatOutput { list } {
    set format { {} status { } WatchDogRef }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} rflexGetWdogRef
interp hide {} rflexGetWdogRefFormatOutput





# SetMode ----------------------------------------------------------

if { [lsearch [interp hidden] rflexSetMode] >= 0 } {
    interp expose {} rflexSetMode
}
if { [lsearch [interp hidden] rflexSetModeFormatOutput] >= 0 } {
    interp expose {} rflexSetModeFormatOutput
}

proc ::rflexSetMode { name args } {
    set format {}
    lappend format [list { "AUTO_MODE" "MANUAL_MODE" } "mode" "" ]

    return [ ::cs::rqstSend "${name}" "SetMode" \
	"** undocumented **" \
	"RFLEX_MODE mode\n" \
	1 \
	$format \
	$args ]
}


proc ::rflexSetModeFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} rflexSetMode
interp hide {} rflexSetModeFormatOutput





# GetMode ----------------------------------------------------------

if { [lsearch [interp hidden] rflexGetMode] >= 0 } {
    interp expose {} rflexGetMode
}
if { [lsearch [interp hidden] rflexGetModeFormatOutput] >= 0 } {
    interp expose {} rflexGetModeFormatOutput
}

proc ::rflexGetMode { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "GetMode" \
	"** undocumented **" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::rflexGetModeFormatOutput { list } {
    set format { {} status { } mode }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} rflexGetMode
interp hide {} rflexGetModeFormatOutput





# PomTagging ----------------------------------------------------------

if { [lsearch [interp hidden] rflexPomTagging] >= 0 } {
    interp expose {} rflexPomTagging
}
if { [lsearch [interp hidden] rflexPomTaggingFormatOutput] >= 0 } {
    interp expose {} rflexPomTaggingFormatOutput
}

proc ::rflexPomTagging { name args } {
    set format {}
    lappend format [list { "RFLEX_DISABLE_POMTAGS" "RFLEX_ENABLE_POMTAGS" } "Tagging method" "RFLEX_DISABLE_POMTAGS" ]

    return [ ::cs::rqstSend "${name}" "PomTagging" \
	"Enable or disable PoM tagging" \
	"RFLEX_POM_TAGGING pomTagging\n" \
	1 \
	$format \
	$args ]
}


proc ::rflexPomTaggingFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} rflexPomTagging
interp hide {} rflexPomTaggingFormatOutput





# SetPos ----------------------------------------------------------

if { [lsearch [interp hidden] rflexSetPos] >= 0 } {
    interp expose {} rflexSetPos
}
if { [lsearch [interp hidden] rflexSetPosFormatOutput] >= 0 } {
    interp expose {} rflexSetPosFormatOutput
}

proc ::rflexSetPos { name args } {
    set format {}
    lappend format [list double "setPosStr.x" 0.0 ]
    lappend format [list double "setPosStr.y" 0.0 ]
    lappend format [list double "setPosStr.z" 0.0 ]
    lappend format [list double "setPosStr.theta" 0.0 ]

    return [ ::cs::rqstSend "${name}" "SetPos" \
	"** undocumented **" \
	"RFLEX_CART_3DCONFIG\n| double x\n| double y\n| double z\n| double theta\n" \
	4 \
	$format \
	$args ]
}


proc ::rflexSetPosFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} rflexSetPos
interp hide {} rflexSetPosFormatOutput





# SetPosFromMEPoster ----------------------------------------------------------

if { [lsearch [interp hidden] rflexSetPosFromMEPoster] >= 0 } {
    interp expose {} rflexSetPosFromMEPoster
}
if { [lsearch [interp hidden] rflexSetPosFromMEPosterFormatOutput] >= 0 } {
    interp expose {} rflexSetPosFromMEPosterFormatOutput
}

proc ::rflexSetPosFromMEPoster { name args } {
    set format {}
    lappend format [list string "Poster name where to read a ref pos" "seglocMEPos" ]

    return [ ::cs::rqstSend "${name}" "SetPosFromMEPoster" \
	"** undocumented **" \
	"RFLEX_STRING\n| char name\[32\]\n" \
	1 \
	$format \
	$args ]
}


proc ::rflexSetPosFromMEPosterFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} rflexSetPosFromMEPoster
interp hide {} rflexSetPosFromMEPosterFormatOutput





# SetPosErr ----------------------------------------------------------

if { [lsearch [interp hidden] rflexSetPosErr] >= 0 } {
    interp expose {} rflexSetPosErr
}
if { [lsearch [interp hidden] rflexSetPosErrFormatOutput] >= 0 } {
    interp expose {} rflexSetPosErrFormatOutput
}

proc ::rflexSetPosErr { name args } {
    set format {}
    for {set loop1(0) 0} { $loop1(0)<6 } { incr loop1(0)} {
    lappend format [list double "setVarTab.var\[$loop1(0)\]" 0.0 ]
}

    return [ ::cs::rqstSend "${name}" "SetPosErr" \
	"** undocumented **" \
	"GENPOS_CART_CONFIG_VAR\n| double var\[6\]\n" \
	6 \
	$format \
	$args ]
}


proc ::rflexSetPosErrFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} rflexSetPosErr
interp hide {} rflexSetPosErrFormatOutput





# SetVarParams ----------------------------------------------------------

if { [lsearch [interp hidden] rflexSetVarParams] >= 0 } {
    interp expose {} rflexSetVarParams
}
if { [lsearch [interp hidden] rflexSetVarParamsFormatOutput] >= 0 } {
    interp expose {} rflexSetVarParamsFormatOutput
}

proc ::rflexSetVarParams { name args } {
    set format {}
    lappend format [list double "varParams.coeffLin" 0.0 ]
    lappend format [list double "varParams.coeffAng" 0.0 ]
    lappend format [list double "varParams.coeffLinAng" 0.0 ]

    return [ ::cs::rqstSend "${name}" "SetVarParams" \
	"** undocumented **" \
	"RFLEX_VAR_PARAMS\n| double coeffLin\n| double coeffAng\n| double coeffLinAng\n" \
	3 \
	$format \
	$args ]
}


proc ::rflexSetVarParamsFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} rflexSetVarParams
interp hide {} rflexSetVarParamsFormatOutput





# Stop ----------------------------------------------------------

if { [lsearch [interp hidden] rflexStop] >= 0 } {
    interp expose {} rflexStop
}
if { [lsearch [interp hidden] rflexStopFormatOutput] >= 0 } {
    interp expose {} rflexStopFormatOutput
}

proc ::rflexStop { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "Stop" \
	"** undocumented **" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::rflexStopFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} rflexStop
interp hide {} rflexStopFormatOutput





# TrackEnd ----------------------------------------------------------

if { [lsearch [interp hidden] rflexTrackEnd] >= 0 } {
    interp expose {} rflexTrackEnd
}
if { [lsearch [interp hidden] rflexTrackEndFormatOutput] >= 0 } {
    interp expose {} rflexTrackEndFormatOutput
}

proc ::rflexTrackEnd { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "TrackEnd" \
	"** undocumented **" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::rflexTrackEndFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} rflexTrackEnd
interp hide {} rflexTrackEndFormatOutput





# GotoSpeed ----------------------------------------------------------

if { [lsearch [interp hidden] rflexGotoSpeed] >= 0 } {
    interp expose {} rflexGotoSpeed
}
if { [lsearch [interp hidden] rflexGotoSpeedFormatOutput] >= 0 } {
    interp expose {} rflexGotoSpeedFormatOutput
}

proc ::rflexGotoSpeed { name args } {
    set format {}
    lappend format [list int "speedRef.numRef" 0 ]
    lappend format [list int "speedRef.updatePeriod" 0 ]
    lappend format [list double "speedRef.v" 0.0 ]
    lappend format [list double "speedRef.vt" 0.0 ]
    lappend format [list double "speedRef.w" 0.0 ]
    lappend format [list double "speedRef.vmax" 0.0 ]
    lappend format [list double "speedRef.wmax" 0.0 ]
    lappend format [list double "speedRef.linAccelMax" 0.0 ]
    lappend format [list double "speedRef.angAccelMax" 0.0 ]

    return [ ::cs::rqstSend "${name}" "GotoSpeed" \
	"** undocumented **" \
	"GENPOS_CART_SPEED\n| int numRef\n| int updatePeriod\n| double v\n| double vt\n| double w\n| double vmax\n| double wmax\n| double linAccelMax\n| double angAccelMax\n" \
	9 \
	$format \
	$args ]
}


proc ::rflexGotoSpeedFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} rflexGotoSpeed
interp hide {} rflexGotoSpeedFormatOutput





# TrackSpeedStart ----------------------------------------------------------

if { [lsearch [interp hidden] rflexTrackSpeedStart] >= 0 } {
    interp expose {} rflexTrackSpeedStart
}
if { [lsearch [interp hidden] rflexTrackSpeedStartFormatOutput] >= 0 } {
    interp expose {} rflexTrackSpeedStartFormatOutput
}

proc ::rflexTrackSpeedStart { name args } {
    set format {}
    lappend format [list string "posterName.name" "" ]

    return [ ::cs::rqstSend "${name}" "TrackSpeedStart" \
	"** undocumented **" \
	"GENPOS_POSTER_NAME\n| char name\[32\]\n" \
	1 \
	$format \
	$args ]
}


proc ::rflexTrackSpeedStartFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} rflexTrackSpeedStart
interp hide {} rflexTrackSpeedStartFormatOutput





# TrackConfigStart ----------------------------------------------------------

if { [lsearch [interp hidden] rflexTrackConfigStart] >= 0 } {
    interp expose {} rflexTrackConfigStart
}
if { [lsearch [interp hidden] rflexTrackConfigStartFormatOutput] >= 0 } {
    interp expose {} rflexTrackConfigStartFormatOutput
}

proc ::rflexTrackConfigStart { name args } {
    set format {}
    lappend format [list string "posterName.name" "" ]

    return [ ::cs::rqstSend "${name}" "TrackConfigStart" \
	"** undocumented **" \
	"GENPOS_POSTER_NAME\n| char name\[32\]\n" \
	1 \
	$format \
	$args ]
}


proc ::rflexTrackConfigStartFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} rflexTrackConfigStart
interp hide {} rflexTrackConfigStartFormatOutput





# GetGeoConfig ----------------------------------------------------------

if { [lsearch [interp hidden] rflexGetGeoConfig] >= 0 } {
    interp expose {} rflexGetGeoConfig
}
if { [lsearch [interp hidden] rflexGetGeoConfigFormatOutput] >= 0 } {
    interp expose {} rflexGetGeoConfigFormatOutput
}

proc ::rflexGetGeoConfig { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "GetGeoConfig" \
	"** undocumented **" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::rflexGetGeoConfigFormatOutput { list } {
    set format { {} status { } { geomParams { } linMToStep { } angRadToStep { } linStepToM { } angStepToRad { } sonarScale { } sonarOffset } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} rflexGetGeoConfig
interp hide {} rflexGetGeoConfigFormatOutput





# SetGeoConfig ----------------------------------------------------------

if { [lsearch [interp hidden] rflexSetGeoConfig] >= 0 } {
    interp expose {} rflexSetGeoConfig
}
if { [lsearch [interp hidden] rflexSetGeoConfigFormatOutput] >= 0 } {
    interp expose {} rflexSetGeoConfigFormatOutput
}

proc ::rflexSetGeoConfig { name args } {
    set format {}
    lappend format [list double "geomParams.linMToStep" 0.0 ]
    lappend format [list double "geomParams.angRadToStep" 0.0 ]
    lappend format [list double "geomParams.linStepToM" 0.0 ]
    lappend format [list double "geomParams.angStepToRad" 0.0 ]
    lappend format [list double "geomParams.sonarScale" 0.0 ]
    lappend format [list double "geomParams.sonarOffset" 0.0 ]

    return [ ::cs::rqstSend "${name}" "SetGeoConfig" \
	"** undocumented **" \
	"RFLEX_GEOM_PARAM_STR\n| double linMToStep\n| double angRadToStep\n| double linStepToM\n| double angStepToRad\n| double sonarScale\n| double sonarOffset\n" \
	6 \
	$format \
	$args ]
}


proc ::rflexSetGeoConfigFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} rflexSetGeoConfig
interp hide {} rflexSetGeoConfigFormatOutput





# SonarOn ----------------------------------------------------------

if { [lsearch [interp hidden] rflexSonarOn] >= 0 } {
    interp expose {} rflexSonarOn
}
if { [lsearch [interp hidden] rflexSonarOnFormatOutput] >= 0 } {
    interp expose {} rflexSonarOnFormatOutput
}

proc ::rflexSonarOn { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "SonarOn" \
	"** undocumented **" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::rflexSonarOnFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} rflexSonarOn
interp hide {} rflexSonarOnFormatOutput





# SonarOff ----------------------------------------------------------

if { [lsearch [interp hidden] rflexSonarOff] >= 0 } {
    interp expose {} rflexSonarOff
}
if { [lsearch [interp hidden] rflexSonarOffFormatOutput] >= 0 } {
    interp expose {} rflexSonarOffFormatOutput
}

proc ::rflexSonarOff { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "SonarOff" \
	"** undocumented **" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::rflexSonarOffFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} rflexSonarOff
interp hide {} rflexSonarOffFormatOutput





# BrakeOn ----------------------------------------------------------

if { [lsearch [interp hidden] rflexBrakeOn] >= 0 } {
    interp expose {} rflexBrakeOn
}
if { [lsearch [interp hidden] rflexBrakeOnFormatOutput] >= 0 } {
    interp expose {} rflexBrakeOnFormatOutput
}

proc ::rflexBrakeOn { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "BrakeOn" \
	"** undocumented **" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::rflexBrakeOnFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} rflexBrakeOn
interp hide {} rflexBrakeOnFormatOutput





# BrakeOff ----------------------------------------------------------

if { [lsearch [interp hidden] rflexBrakeOff] >= 0 } {
    interp expose {} rflexBrakeOff
}
if { [lsearch [interp hidden] rflexBrakeOffFormatOutput] >= 0 } {
    interp expose {} rflexBrakeOffFormatOutput
}

proc ::rflexBrakeOff { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "BrakeOff" \
	"** undocumented **" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::rflexBrakeOffFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} rflexBrakeOff
interp hide {} rflexBrakeOffFormatOutput





# GetJoystick ----------------------------------------------------------

if { [lsearch [interp hidden] rflexGetJoystick] >= 0 } {
    interp expose {} rflexGetJoystick
}
if { [lsearch [interp hidden] rflexGetJoystickFormatOutput] >= 0 } {
    interp expose {} rflexGetJoystickFormatOutput
}

proc ::rflexGetJoystick { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "GetJoystick" \
	"** undocumented **" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::rflexGetJoystickFormatOutput { list } {
    set format { {} status { } { joystickState { } x { } y { } buttons { } unused } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} rflexGetJoystick
interp hide {} rflexGetJoystickFormatOutput





# MonitorBattery ----------------------------------------------------------

if { [lsearch [interp hidden] rflexMonitorBattery] >= 0 } {
    interp expose {} rflexMonitorBattery
}
if { [lsearch [interp hidden] rflexMonitorBatteryFormatOutput] >= 0 } {
    interp expose {} rflexMonitorBatteryFormatOutput
}

proc ::rflexMonitorBattery { name args } {
    set format {}
    lappend format [list { "RFLEX_BATTERY_HIGH" "RFLEX_BATTERY_MEDIUM" "RFLEX_BATTERY_LOW" } "The status to monitor" "RFLEX_BATTERY_LOW" ]

    return [ ::cs::rqstSend "${name}" "MonitorBattery" \
	"Monitor if batteriy is get low" \
	"RFLEX_BATTERY_STATUS statusToMonitor\n" \
	1 \
	$format \
	$args ]
}


proc ::rflexMonitorBatteryFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} rflexMonitorBattery
interp hide {} rflexMonitorBatteryFormatOutput





# Gyro ----------------------------------------------------------

if { [lsearch [interp hidden] rflexGyro] >= 0 } {
    interp expose {} rflexGyro
}
if { [lsearch [interp hidden] rflexGyroFormatOutput] >= 0 } {
    interp expose {} rflexGyroFormatOutput
}

proc ::rflexGyro { name args } {
    set format {}
    lappend format [list { "RFLEX_GYRO_ON" "RFLEX_GYRO_ON_IF_MOTION" "RFLEX_GYRO_OFF" } "params.mode" "" ]
    lappend format [list int "params.unused" 0 ]
    lappend format [list string "params.port" "" ]

    return [ ::cs::rqstSend "${name}" "Gyro" \
	"Gyro configuration" \
	"RFLEX_GYRO_PARAMS\n| RFLEX_GYRO_MODE mode\n| int unused\n| char port\[32\]\n" \
	3 \
	$format \
	$args ]
}


proc ::rflexGyroFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} rflexGyro
interp hide {} rflexGyroFormatOutput





# GetGyro ----------------------------------------------------------

if { [lsearch [interp hidden] rflexGetGyro] >= 0 } {
    interp expose {} rflexGetGyro
}
if { [lsearch [interp hidden] rflexGetGyroFormatOutput] >= 0 } {
    interp expose {} rflexGetGyroFormatOutput
}

proc ::rflexGetGyro { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "GetGyro" \
	"<some doc>" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::rflexGetGyroFormatOutput { list } {
    set format { {} status { } { params { } mode { } unused { } port } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} rflexGetGyro
interp hide {} rflexGetGyroFormatOutput





# SetOdometryMethod ----------------------------------------------------------

if { [lsearch [interp hidden] rflexSetOdometryMethod] >= 0 } {
    interp expose {} rflexSetOdometryMethod
}
if { [lsearch [interp hidden] rflexSetOdometryMethodFormatOutput] >= 0 } {
    interp expose {} rflexSetOdometryMethodFormatOutput
}

proc ::rflexSetOdometryMethod { name args } {
    set format {}
    lappend format [list { "RFLEX_ODO_3D" "RFLEX_ODO_2D" } "Odometry Method" "RFLEX_ODO_2D" ]
    lappend format [list int "unused" 0 ]
    lappend format [list string "Attitude Poster Name" "imuAttitudeEstimation" ]

    return [ ::cs::rqstSend "${name}" "SetOdometryMethod" \
	"Odometry Configuration" \
	"RFLEX_ODOMETRY_METHOD\n| RFLEX_ODOMETRY_MODE mode\n| int unused\n| char attitudePosterName\[64\]\n" \
	3 \
	$format \
	$args ]
}


proc ::rflexSetOdometryMethodFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} rflexSetOdometryMethod
interp hide {} rflexSetOdometryMethodFormatOutput





# Log ----------------------------------------------------------

if { [lsearch [interp hidden] rflexLog] >= 0 } {
    interp expose {} rflexLog
}
if { [lsearch [interp hidden] rflexLogFormatOutput] >= 0 } {
    interp expose {} rflexLogFormatOutput
}

proc ::rflexLog { name args } {
    set format {}
    lappend format [list string "fileName.name" "" ]

    return [ ::cs::rqstSend "${name}" "Log" \
	"Log robot configuration and date" \
	"GEN_STRING128\n| char name\[128\]\n" \
	1 \
	$format \
	$args ]
}


proc ::rflexLogFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} rflexLog
interp hide {} rflexLogFormatOutput





# StopLog ----------------------------------------------------------

if { [lsearch [interp hidden] rflexStopLog] >= 0 } {
    interp expose {} rflexStopLog
}
if { [lsearch [interp hidden] rflexStopLogFormatOutput] >= 0 } {
    interp expose {} rflexStopLogFormatOutput
}

proc ::rflexStopLog { name args } {
    set format {}

    return [ ::cs::rqstSend "${name}" "StopLog" \
	"Stop activity Log" \
	"no arguments" \
	0 \
	$format \
	$args ]
}


proc ::rflexStopLogFormatOutput { list } {
    set format { {} status }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} rflexStopLog
interp hide {} rflexStopLogFormatOutput





# RobotPosition ----------------------------------------------------------

if { [lsearch [interp hidden] rflexRobotPositionPosterRead] >= 0 } {
    interp expose {} rflexRobotPositionPosterRead
}
if { [lsearch [interp hidden] rflexRobotPositionPosterFormatOutput] >= 0 } {
    interp expose {} rflexRobotPositionPosterFormatOutput
}

proc ::rflexRobotPositionPosterRead { name args } {

    return [ ::cs::posterRead "${name}" "RobotPosition" \
	"RFLEX_CART_3DSTATE\n| double xRef\n| double yRef\n| double zRef\n| double xRob\n| double yRob\n| double zRob\n| double theta\n| double pitch\n| double roll\n| double v\n| double vt\n| double w\n" \
	$args ]
}


proc ::rflexRobotPositionPosterFormatOutput { list } {
    set format { {} status { } { Position { } xRef { } yRef { } zRef { } xRob { } yRob { } zRob { } theta { } pitch { } roll { } v { } vt { } w } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} rflexRobotPositionPosterRead
interp hide {} rflexRobotPositionPosterFormatOutput





# RobotrawAxis ----------------------------------------------------------

if { [lsearch [interp hidden] rflexRobotrawAxisPosterRead] >= 0 } {
    interp expose {} rflexRobotrawAxisPosterRead
}
if { [lsearch [interp hidden] rflexRobotrawAxisPosterFormatOutput] >= 0 } {
    interp expose {} rflexRobotrawAxisPosterFormatOutput
}

proc ::rflexRobotrawAxisPosterRead { name args } {

    return [ ::cs::posterRead "${name}" "RobotrawAxis" \
	"RFLEX_RAW_AXIS_STR\n| int pos\n| int vel\n| int acc\n| int trq\n" \
	$args ]
}


proc ::rflexRobotrawAxisPosterFormatOutput { list } {
    set format { {} status { 2 } { rawAxis { } pos { } vel { } acc { } trq } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} rflexRobotrawAxisPosterRead
interp hide {} rflexRobotrawAxisPosterFormatOutput





# RobotPosError ----------------------------------------------------------

if { [lsearch [interp hidden] rflexRobotPosErrorPosterRead] >= 0 } {
    interp expose {} rflexRobotPosErrorPosterRead
}
if { [lsearch [interp hidden] rflexRobotPosErrorPosterFormatOutput] >= 0 } {
    interp expose {} rflexRobotPosErrorPosterFormatOutput
}

proc ::rflexRobotPosErrorPosterRead { name args } {

    return [ ::cs::posterRead "${name}" "RobotPosError" \
	"GENPOS_CART_CONFIG_VAR\n| double var\[6\]\n" \
	$args ]
}


proc ::rflexRobotPosErrorPosterFormatOutput { list } {
    set format { {} status { } { PosError { 6 } var } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} rflexRobotPosErrorPosterRead
interp hide {} rflexRobotPosErrorPosterFormatOutput





# RobotconfigRef ----------------------------------------------------------

if { [lsearch [interp hidden] rflexRobotconfigRefPosterRead] >= 0 } {
    interp expose {} rflexRobotconfigRefPosterRead
}
if { [lsearch [interp hidden] rflexRobotconfigRefPosterFormatOutput] >= 0 } {
    interp expose {} rflexRobotconfigRefPosterFormatOutput
}

proc ::rflexRobotconfigRefPosterRead { name args } {

    return [ ::cs::posterRead "${name}" "RobotconfigRef" \
	"GENPOS_CART_REF\n| int numRef\n| int tickPeriod\n| GENPOS_DATA_TYPE dataType\n| GENPOS_MOTION_DIRECTION backFlag\n| double x\n| double y\n| double theta\n| double v\n| double vt\n| double w\n| double vmax\n| double wmax\n| double linAccelMax\n| double angAccelMax\n" \
	$args ]
}


proc ::rflexRobotconfigRefPosterFormatOutput { list } {
    set format { {} status { } { configRef { } numRef { } tickPeriod { } dataType { } backFlag { } x { } y { } theta { } v { } vt { } w { } vmax { } wmax { } linAccelMax { } angAccelMax } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} rflexRobotconfigRefPosterRead
interp hide {} rflexRobotconfigRefPosterFormatOutput





# RobotspeedRef ----------------------------------------------------------

if { [lsearch [interp hidden] rflexRobotspeedRefPosterRead] >= 0 } {
    interp expose {} rflexRobotspeedRefPosterRead
}
if { [lsearch [interp hidden] rflexRobotspeedRefPosterFormatOutput] >= 0 } {
    interp expose {} rflexRobotspeedRefPosterFormatOutput
}

proc ::rflexRobotspeedRefPosterRead { name args } {

    return [ ::cs::posterRead "${name}" "RobotspeedRef" \
	"GENPOS_CART_SPEED\n| int numRef\n| int updatePeriod\n| double v\n| double vt\n| double w\n| double vmax\n| double wmax\n| double linAccelMax\n| double angAccelMax\n" \
	$args ]
}


proc ::rflexRobotspeedRefPosterFormatOutput { list } {
    set format { {} status { } { speedRef { } numRef { } updatePeriod { } v { } vt { } w { } vmax { } wmax { } linAccelMax { } angAccelMax } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} rflexRobotspeedRefPosterRead
interp hide {} rflexRobotspeedRefPosterFormatOutput





# RobotsystemState ----------------------------------------------------------

if { [lsearch [interp hidden] rflexRobotsystemStatePosterRead] >= 0 } {
    interp expose {} rflexRobotsystemStatePosterRead
}
if { [lsearch [interp hidden] rflexRobotsystemStatePosterFormatOutput] >= 0 } {
    interp expose {} rflexRobotsystemStatePosterFormatOutput
}

proc ::rflexRobotsystemStatePosterRead { name args } {

    return [ ::cs::posterRead "${name}" "RobotsystemState" \
	"RFLEX_SYSTEM_STATE_STR\n| RFLEX_MODE mode\n| int brake\n| int shock\n| RFLEX_BATTERY_STATUS batteryStatus\n| double batteryLevel\n| double highBatteryLevel\n| double mediumBatteryLevel\n| double lowBatteryLevel\n" \
	$args ]
}


proc ::rflexRobotsystemStatePosterFormatOutput { list } {
    set format { {} status { } { systemState { } mode { } brake { } shock { } batteryStatus { } batteryLevel { } highBatteryLevel { } mediumBatteryLevel { } lowBatteryLevel } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} rflexRobotsystemStatePosterRead
interp hide {} rflexRobotsystemStatePosterFormatOutput





# RobotmiscOdo ----------------------------------------------------------

if { [lsearch [interp hidden] rflexRobotmiscOdoPosterRead] >= 0 } {
    interp expose {} rflexRobotmiscOdoPosterRead
}
if { [lsearch [interp hidden] rflexRobotmiscOdoPosterFormatOutput] >= 0 } {
    interp expose {} rflexRobotmiscOdoPosterFormatOutput
}

proc ::rflexRobotmiscOdoPosterRead { name args } {

    return [ ::cs::posterRead "${name}" "RobotmiscOdo" \
	"RFLEX_MISC_ODO\n| double s\n| long int sInit\n" \
	$args ]
}


proc ::rflexRobotmiscOdoPosterFormatOutput { list } {
    set format { {} status { } { miscOdo { } s { } sInit } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} rflexRobotmiscOdoPosterRead
interp hide {} rflexRobotmiscOdoPosterFormatOutput





# MEPosPos ----------------------------------------------------------

if { [lsearch [interp hidden] rflexMEPosPosPosterRead] >= 0 } {
    interp expose {} rflexMEPosPosPosterRead
}
if { [lsearch [interp hidden] rflexMEPosPosPosterFormatOutput] >= 0 } {
    interp expose {} rflexMEPosPosPosterFormatOutput
}

proc ::rflexMEPosPosPosterRead { name args } {

    return [ ::cs::posterRead "${name}" "MEPosPos" \
	"POM_ME_POS\n| POM_ME_CLASS kind\n| int unused\n| double confidence\n| int date1\n| int date2\n| POM_EULER_V\n| | POM_EULER\n| | | double yaw\n| | | double pitch\n| | | double roll\n| | | double x\n| | | double y\n| | | double z\n| | POM_EULER_VARIANCES\n| | | double voo\n| | | double vop\n| | | double vpp\n| | | double vor\n| | | double vpr\n| | | double vrr\n| | | double vox\n| | | double vpx\n| | | double vrx\n| | | double vxx\n| | | double voy\n| | | double vpy\n| | | double vry\n| | | double vxy\n| | | double vyy\n| | | double voz\n| | | double vpz\n| | | double vrz\n| | | double vxz\n| | | double vyz\n| | | double vzz\n| POM_EULER_V\n| | POM_EULER\n| | | double yaw\n| | | double pitch\n| | | double roll\n| | | double x\n| | | double y\n| | | double z\n| | POM_EULER_VARIANCES\n| | | double voo\n| | | double vop\n| | | double vpp\n| | | double vor\n| | | double vpr\n| | | double vrr\n| | | double vox\n| | | double vpx\n| | | double vrx\n| | | double vxx\n| | | double voy\n| | | double vpy\n| | | double vry\n| | | double vxy\n| | | double vyy\n| | | double voz\n| | | double vpz\n| | | double vrz\n| | | double vxz\n| | | double vyz\n| | | double vzz\n" \
	$args ]
}


proc ::rflexMEPosPosPosterFormatOutput { list } {
    set format { {} status { } { Pos { } kind { } unused { } confidence { } date1 { } date2 { } { main { } { euler { } yaw { } pitch { } roll { } x { } y { } z } { } { var { } voo { } vop { } vpp { } vor { } vpr { } vrr { } vox { } vpx { } vrx { } vxx { } voy { } vpy { } vry { } vxy { } vyy { } voz { } vpz { } vrz { } vxz { } vyz { } vzz } } { } { VLocal { } { euler { } yaw { } pitch { } roll { } x { } y { } z } { } { var { } voo { } vop { } vpp { } vor { } vpr { } vrr { } vox { } vpx { } vrx { } vxx { } voy { } vpy { } vry { } vxy { } vyy { } voz { } vpz { } vrz { } vxz { } vyz { } vzz } } } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} rflexMEPosPosPosterRead
interp hide {} rflexMEPosPosPosterFormatOutput





# SonarsConfigConfig ----------------------------------------------------------

if { [lsearch [interp hidden] rflexSonarsConfigConfigPosterRead] >= 0 } {
    interp expose {} rflexSonarsConfigConfigPosterRead
}
if { [lsearch [interp hidden] rflexSonarsConfigConfigPosterFormatOutput] >= 0 } {
    interp expose {} rflexSonarsConfigConfigPosterFormatOutput
}

proc ::rflexSonarsConfigConfigPosterRead { name args } {

    return [ ::cs::posterRead "${name}" "SonarsConfigConfig" \
	"RFLEX_SONARS_CONFIG\n| RFLEX_CONFIG\n| | double x\n| | double y\n| | double theta\n" \
	$args ]
}


proc ::rflexSonarsConfigConfigPosterFormatOutput { list } {
    set format { {} status { } { Config { 12 } { tab { } x { } y { } theta } } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} rflexSonarsConfigConfigPosterRead
interp hide {} rflexSonarsConfigConfigPosterFormatOutput





# SonarsRhoRange ----------------------------------------------------------

if { [lsearch [interp hidden] rflexSonarsRhoRangePosterRead] >= 0 } {
    interp expose {} rflexSonarsRhoRangePosterRead
}
if { [lsearch [interp hidden] rflexSonarsRhoRangePosterFormatOutput] >= 0 } {
    interp expose {} rflexSonarsRhoRangePosterFormatOutput
}

proc ::rflexSonarsRhoRangePosterRead { name args } {

    return [ ::cs::posterRead "${name}" "SonarsRhoRange" \
	"RFLEX_SONARS_RANGE\n| double tab\[12\]\n" \
	$args ]
}


proc ::rflexSonarsRhoRangePosterFormatOutput { list } {
    set format { {} status { } { Range { 12 } tab } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} rflexSonarsRhoRangePosterRead
interp hide {} rflexSonarsRhoRangePosterFormatOutput





# SonarsCartMeasureInRobotCart ----------------------------------------------------------

if { [lsearch [interp hidden] rflexSonarsCartMeasureInRobotCartPosterRead] >= 0 } {
    interp expose {} rflexSonarsCartMeasureInRobotCartPosterRead
}
if { [lsearch [interp hidden] rflexSonarsCartMeasureInRobotCartPosterFormatOutput] >= 0 } {
    interp expose {} rflexSonarsCartMeasureInRobotCartPosterFormatOutput
}

proc ::rflexSonarsCartMeasureInRobotCartPosterRead { name args } {

    return [ ::cs::posterRead "${name}" "SonarsCartMeasureInRobotCart" \
	"RFLEX_SONARS_CART_MEASURES\n| RFLEX_POINT\n| | double x\n| | double y\n" \
	$args ]
}


proc ::rflexSonarsCartMeasureInRobotCartPosterFormatOutput { list } {
    set format { {} status { } { MeasureInRobotCart { 12 } { tab { } x { } y } } }

    set out ""
    interp invokehidden {} rqstFormatOuput $format out list ""
    return [join $out "\n"]
}

interp hide {} rflexSonarsCartMeasureInRobotCartPosterRead
interp hide {} rflexSonarsCartMeasureInRobotCartPosterFormatOutput


